import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Creature1  extends Actor
{
    private static final int SPEED = 2;
    
    private int deltaX;
    private int deltaY;

    public Creature1()
    {
        deltaX = 0;
        deltaY = 0;
    }

    public void randomWalk()
    {
        if (randomChance(50)) {
            deltaX = adjustSpeed(deltaX);
            deltaY = adjustSpeed(deltaY);
        }
        walk();
    }

    public void walk()
    {
        setLocation(getX() + deltaX, getY() + deltaY);
        setRotation((int) (180 * Math.atan2(deltaY, deltaX) / Math.PI));
    }
    
    public void walk(int deltaX, int deltaY)
    {
        deltaX = adjustSpeed(deltaX);
        deltaY = adjustSpeed(deltaY);
        setLocation(getX() + deltaX, getY() + deltaY);
    }

    private int adjustSpeed(int speed)
    {
        speed = speed + Greenfoot.getRandomNumber(2 * SPEED - 1) - SPEED + 1;
        return capSpeed(speed);
    }

    private int capSpeed(int speed)
    {
        if (speed < -SPEED)
            return -SPEED;
        else if (speed > SPEED)
            return SPEED;
        else
            return speed;
    }

    private boolean randomChance(int percent)
    {
        return Greenfoot.getRandomNumber(100) < percent;
    }
}
