import greenfoot.*;
import java.util.List;

public class SuperAttack extends Actor
{   
    private static final int NUMBER_IMAGES= 30;

    private static GreenfootImage[] images;
    
    private int imageCount = 0;

    public SuperAttack() 
    {
        initializeImages();
        setImage(images[0]);
    }

    public static void initializeImages() 
    {
        if (images == null){
            GreenfootImage baseImage = new GreenfootImage("superattack.png");
            images = new GreenfootImage[NUMBER_IMAGES];
            for (int i = 0; i < NUMBER_IMAGES; i++){
                int size = (i+1) * ( baseImage.getWidth() / NUMBER_IMAGES / 5 * 4);
                images[i] = new GreenfootImage(baseImage);
                images[i].scale(size, size);
            }
        }
    }

    public void act()
    { 
        checkCollision();
        grow();
    }

    private void checkCollision()
    {
        int range = getImage().getWidth() / 2;
        List<Amy> amy = getObjectsInRange(range, Amy.class);     
        
        for (Amy a : amy){
            a.damege(1);
        }
        
        List<Temple> temple = getObjectsInRange(range, Temple.class);
        
        for (Temple b : temple){
            b.damege(1);
        }
    }

    private void grow()
    {
        if (imageCount >= NUMBER_IMAGES){
            getWorld().removeObject(this);
        }
        else{
            setImage(images[imageCount]);
            imageCount++;
        }
    }
}
